--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    10:47:44 01/27/06
-- Design Name:    
-- Module Name:    M64_1 - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity M32_1 is
    Port ( d : in std_logic_vector(31 downto 0);
           s : in std_logic_vector(4 downto 0);
           o : out std_logic);
end M32_1;

architecture Behavioral of M32_1 is
begin
process(d,s)
begin
  case s is
    when "00000" => o <= d(0);
    when "00001" => o <= d(1);
    when "00010" => o <= d(2);
    when "00011" => o <= d(3);
    when "00100" => o <= d(4);
    when "00101" => o <= d(5);
    when "00110" => o <= d(6);
    when "00111" => o <= d(7);
    when "01000" => o <= d(8);
    when "01001" => o <= d(9);
    when "01010" => o <= d(10);
    when "01011" => o <= d(11);
    when "01100" => o <= d(12);
    when "01101" => o <= d(13);
    when "01110" => o <= d(14);
    when "01111" => o <= d(15);
    when "10000" => o <= d(16);
    when "10001" => o <= d(17);
    when "10010" => o <= d(18);
    when "10011" => o <= d(19);
    when "10100" => o <= d(20);
    when "10101" => o <= d(21);
    when "10110" => o <= d(22);
    when "10111" => o <= d(23);
    when "11000" => o <= d(24);
    when "11001" => o <= d(25);
    when "11010" => o <= d(26);
    when "11011" => o <= d(27);
    when "11100" => o <= d(28);
    when "11101" => o <= d(29);
    when "11110" => o <= d(30);
    when others => o <= d(31);
  end case;
end process;

end Behavioral;
